package me.Demon.DemonTrash;

import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class AdminGui implements Listener {

    public static String inv_Title = "管理员垃圾桶(右键物品即可取出)#";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getView().getTitle().contains(inv_Title)) {
            e.setCancelled(true);
            int Pages = Integer.parseInt(e.getView().getTitle().replace(inv_Title, ""));
            if (e.getRawSlot() == 45) {
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                if (Pages >= 2 && Pages <= 15) {
                    AdminGui.OpenGui(p, Pages - 1);
                } else {
                    p.sendMessage(Main.prefix + "§c已经是第一页了！");
                }
            }
            if (e.getRawSlot() == 53) {
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                if (Pages >= 1 && Pages <= 14) {
                    AdminGui.OpenGui(p, Pages + 1);
                } else {
                    p.sendMessage(Main.prefix + "§c已经是最后一页了！");
                }
            }
            if (e.getRawSlot() >= 0 && e.getRawSlot() <= 44) {
                if (!DemonAPI.itemIsNull(e.getCurrentItem()) && !DemonAPI.itemIsLore(e.getCurrentItem())) {
                    String playName = null;
                    String keyId = null;
                    ItemStack item = e.getCurrentItem();
                    ItemMeta meta = item.getItemMeta();
                    for (String str : meta.getLore()) {
                        if (str.startsWith("§a§l★§7物品主人: §f")) {
                            playName = str.replace("§a§l★§7物品主人: §f", "");
                        }
                        if (str.startsWith("§a§l★§7物品序号: §f")) {
                            keyId = str.replace("§a§l★§7物品序号: §f", "");
                        }
                    }
                    String key = playName + "#" + keyId;
                    if (e.getClick() == ClickType.LEFT) {
                        ItemStack items = Main.DataG.getItemStack("TrashItems." + key + ".Items");
                        p.getInventory().addItem(items);
                        p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                        Main.DataG.set("TrashItems." + key, null);
                        Main.KeyList.remove(key);
                        Main.saveDataStatsConfig();
                        AdminGui.OpenGui(p, Pages);
                    }
                    if (e.getClick() == ClickType.SHIFT_RIGHT) {
                        p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                        Main.DataG.set("TrashItems." + key, null);
                        Main.KeyList.remove(key);
                        Main.saveDataStatsConfig();
                        AdminGui.OpenGui(p, Pages);
                    }
                }
            }
        }
    }

    public static void OpenGui(Player p, int Paper) {
        String title = inv_Title + Paper;
        Inventory inv = Bukkit.createInventory(null, 54, title);
        for (int i = 46; i < 53; i++) {
            inv.setItem(i, glass(15, "§7[[§a▧§c▧§a▧§7]]"));
        }
        inv.setItem(45, Paper_Butt("§a上一页"));
        inv.setItem(53, Paper_Butt("§a下一页"));
        List<String> New_KeyList = Main.KeyList;
        if (New_KeyList.size() >= 1) {
            int amount = New_KeyList.size() - 1;
            int addamount = Paper * 36;
            if (Paper == 1) {
                for (int i = amount; i > -1; i--) {
                    if (New_KeyList.get(i) == null) {
                        break;
                    }
                    String key = Main.KeyList.get(i);
                    String str = "TrashItems." + key + ".";
                    String playName = key.split("#")[0];
                    String keyID = key.split("#")[1];
                    String time = Main.DataG.getString(str + "DropTime");
                    ItemStack items = Main.DataG.getItemStack(str + "Items");
                    inv.addItem(ItemsShow(playName, items, keyID, time));
                }
            } else {
                for (int i = amount - (addamount - 9); i > (amount - addamount); i--) {
                    if (i >= 0) {
                        String key = New_KeyList.get(i);
                        String str = "TrashItems." + key + ".";
                        String playName = key.split("#")[0];
                        String keyID = key.split("#")[1];
                        String time = Main.DataG.getString(str + "DropTime");
                        ItemStack items = Main.DataG.getItemStack(str + "Items");
                        inv.addItem(ItemsShow(playName, items, keyID, time));
                    }
                }
            }
        }
        p.openInventory(inv);
    }


    public static ItemStack ItemsShow(String playName, ItemStack itemStack, String keyID, String time) {
        ItemStack item = itemStack.clone();
        ItemMeta meta = item.getItemMeta();
        List<String> lore = new ArrayList<>(itemStack.getItemMeta().getLore());
        lore.add("§7-------------------------");
        lore.add("§a§l★§7物品主人: §f" + playName);
        lore.add("§a§l★§7物品序号: §f" + keyID);
        lore.add("§a§l★§7丢弃时间: §f" + time);
        lore.add(" ");
        lore.add("§e§l★§7左键点击取出此物品");
        lore.add("§e§l★§7SHIFT+右键点击删除此物品");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.addItemFlags(ItemFlag.HIDE_UNBREAKABLE);
        meta.addItemFlags(ItemFlag.HIDE_POTION_EFFECTS);
        item.setItemMeta(meta);
        return item;
    }


    public static ItemStack Paper_Butt(String name) {
        ItemStack item = new ItemStack(Material.ARROW);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7点击翻页 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack glass(int data, String name) {
        ItemStack item = new ItemStack(160, 1, (short) data);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }
}
