package me.Demon.DemonTrash;

import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

public class Main extends JavaPlugin implements Listener {

    public static Main plugin;
    public static String prefix = "§7[§6废品处理§7] §f";
    //获取序列号
    public static List<String> KeyList = new ArrayList<>();
    public static List<String> BlackNoItemList = new ArrayList<>();
    public static File Datafile = new File("plugins/DemonTrash", "Data.yml");
    public static FileConfiguration DataG = YamlConfiguration.loadConfiguration(Datafile);
    public static void saveDataStatsConfig(){ try { Main.DataG.save(Datafile); }catch (IOException e){e.printStackTrace();} }

    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        BlackNoItemList.addAll(getConfig().getStringList("AntiItemsLore"));
        // 获取今天是否是15号
        int time = Integer.parseInt(getTime("dd"));
        if(time == 15){
            int a = 0;
            // 清理非本月的所有垃圾
            FileConfiguration yml = Main.DataG;
            for (String key : yml.getConfigurationSection("TrashItems").getKeys(false)){
                String trash_time = yml.getString("TrashItems."+key + ".DropTime");
                if(!trash_time.split("-")[0].equalsIgnoreCase(getTime("MM"))){
                    yml.set("TrashItems."+key,null);
                    a++;
                }
            }
            Main.saveDataStatsConfig();
            Bukkit.getConsoleSender().sendMessage("§3[魂式垃圾箱] §e总计清理历史垃圾 §a"+a+"件");
        }
        if(Main.DataG.getConfigurationSection("TrashItems") != null) {
            KeyList.addAll(Main.DataG.getConfigurationSection("TrashItems").getKeys(false));
        }
        Bukkit.getPluginManager().registerEvents(this, this);
        Bukkit.getServer().getPluginManager().registerEvents(new MainGui(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new AdminGui(), plugin);
        Bukkit.getConsoleSender().sendMessage("§3[魂式垃圾箱] §a插件成功载入Server！");
        Bukkit.getConsoleSender().sendMessage("§3[魂式垃圾箱] §a妖魂QQ:1763917516");
    }

    public void onDisable() {
        Bukkit.getConsoleSender().sendMessage("§3[魂式垃圾箱] §c插件已正常关闭！");
    }

    public boolean onCommand(CommandSender sender, Command cmd, String CommandLabel, String[] args) {
        if (CommandLabel.equalsIgnoreCase("ljt")) {
            Player p = (Player) sender;
            MainGui.OpenGui(p);
        }
        if (CommandLabel.equalsIgnoreCase("trash")) {
            if (!sender.isOp()) {
                sender.sendMessage("§7[§6帝國戰爭§7] §f指令無效.");
                return true;
            }
            if (args.length == 1 && args[0].equalsIgnoreCase("qingli")) {
                if (Main.DataG.getConfigurationSection("TrashItems") != null) {
                    for (String key : Main.DataG.getConfigurationSection("TrashItems").getKeys(false)) {
                        Main.DataG.set("TrashItems." + key, null);
                    }
                    Main.saveDataStatsConfig();
                }
                sender.sendMessage(prefix + "总计清理 §e" + KeyList.size() + " §f件。");
                KeyList.clear();
            } else{
                AdminGui.OpenGui((Player) sender, 1);
            }
        }
        return false;
    }

    public static String getTime(String format){
        Date date = Calendar.getInstance().getTime();
        SimpleDateFormat datatime = new SimpleDateFormat(format);
        return datatime.format(date);
    }
}
