package me.Demon.DemonTrash;

import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

public class MainGui implements Listener {

    public static void OpenGui(Player p){
        String title = "公共垃圾桶(请把不要的物品放进来)";
        Inventory inv = Bukkit.createInventory(null,18,title);
        p.openInventory(inv);
        p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK,1,2);
    }

    @EventHandler
    public void onclose(InventoryCloseEvent e){
        Player p = (Player) e.getPlayer();
        if(e.getView().getTitle().equalsIgnoreCase("公共垃圾桶(请把不要的物品放进来)")){
            Inventory inv = e.getInventory();
            Inventory newInv = Bukkit.createInventory(null,18,"公共垃圾桶(请再次确认你要丢弃的物品)");
            for (int i = 0;i< 18;i++){
                ItemStack item = inv.getItem(i);
                if(!DemonAPI.itemIsNull(item)){
                    newInv.addItem(item);
                }
            }
            int amount = 0;
            for (int i = 0; i < 18; i++) {
                ItemStack item = newInv.getItem(i);
                if(!DemonAPI.itemIsNull(item)) {
                    if(!DemonAPI.itemIsLore(item)) {
                        TrashAPI.addItemsTrash(p.getName(), item);
                    }
                    amount = amount + item.getAmount();
                }
            }
            if(amount >= 1) {
                p.sendMessage(Main.prefix + "本次总计处理§e" + amount + "样§f你丢弃的废品。");
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
            }
        }
    }

}
